from time import localtime,sleep
import usb

def find_board():
    board = None
    for bus in usb.busses():
        for dev in bus.devices:
            if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                return dev
    return None
board = find_board()
handle = board.open()
def ring():
    a=1
    #print a
    while(a):
        if a%2==0:
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
            handle.controlMsg(req, 0, None, value=0x0105)
        if a%2!=0:
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
            handle.controlMsg(req, 0, None, value=0x0005)
        sleep(0.1)
        a=a+1
        req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        t = handle.controlMsg(req, 4, 1)
        #print t[0]
        if t[0] == 1:
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
            handle.controlMsg(req, 0, None, value=0x0005)
            break
def status():
        seled = raw_input()
        if seled == '0':
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
            t = handle.controlMsg(req, 1,1,0)
            if t[0] ==0:
                print "Switch 0 is currently On Turn Off now (y/n)"
                req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                handle.controlMsg(req, 0, None, value=0x0100)
                ans = raw_input()
                if ans =='y':
                    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                    handle.controlMsg(req, 0, None, value=0x0000)
                
            if t[0] ==1:
                print "Switch 0 is currently Off Turn On now (y/n)"
                ans = raw_input()
                if ans =='y':
                    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                    handle.controlMsg(req, 0, None, value=0x0100)
        if seled == '1':
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
            t = handle.controlMsg(req, 1,1,value=0x0101)
            if t[0] ==0:
                print "Switch 1 is currently On Turn Off now (y/n)"
                req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                handle.controlMsg(req, 0, None, value=0x0101)
                ans = raw_input()
                if ans =='y':
                    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                    handle.controlMsg(req, 0, None, value=0x0001)
            if t[0] ==1:
                print "Switch 1 is currently Off Turn On now (y/n)"
                ans = raw_input()
                if ans =='y':
                    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                    handle.controlMsg(req, 0, None, value=0x0101)
        if seled == '2':
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
            t = handle.controlMsg(req, 1,1,value=0x0102)
            if t[0] ==0:
                print "Switch 2 is currently On Turn Off now (y/n)"
                req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                handle.controlMsg(req, 0, None, value=0x0102)
                ans = raw_input()
                if ans =='y':
                    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                    handle.controlMsg(req, 0, None, value=0x0002)
            if t[0] ==1:
                print "Switch 2 is currently Off Turn On now (y/n)"
                ans = raw_input()
                if ans =='y':
                    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
                    handle.controlMsg(req, 0, None, value=0x0102)

def get_switch():
    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    handle.controlMsg(req, 4, 1)
    return t[0]
def settime(h,m):    
    #hr = raw_input()
    #min = raw_input()
    hr = int(h)
    sec = 0
    min = int(m)
    a=1
    while(a):
        tmp = localtime()
        sleep(1)
        print tmp[3],tmp[4],tmp[5]
        req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        t = handle.controlMsg(req, 4, 1)
        if t[0] == 1:
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
            handle.controlMsg(req, 0, None, value=0x0005)
            break
        if hr == tmp[3]:
            if min == tmp[4]:
                if sec == tmp[5]:
                    ring()
                    break
def count(m,s):
    #min = raw_input()
    #sec = raw_input()
    min = int(m)
    sec = int(s)
    while(1):
        req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        t = handle.controlMsg(req, 4, 1)
        if t[0] == 1:
            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
            handle.controlMsg(req, 0, None, value=0x0005)
            break
        if (sec is 0 and min is not 0):
            sec = 59
            min = min-1
        else:
            if (sec is 0):
                ring()
                break
            else:
                sec = sec-1
        sleep(1)
        print min,"min", sec,"sec"
def test():
    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
    t = handle.controlMsg(req, 4, 1)
    print t
def menu():
    print "========== M E N U =========="
    print "1.Status"
    print "2.Set Time"
    print "3.Countdown"
    print "4.Quit"
    print "============================="
#req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
#handle.controlMsg(req, 0, None, value=0x0101)
#ring()
#while(1):
#    menu()
#    inp = raw_input()
#    if inp == '1':
#        status()
#    elif inp=='2':
#        settime()
#    elif inp=='4':
#        exit()
#    elif inp=='3':
#        count()
#    elif inp=='5':
#        ring()
#    elif inp=='6':
#        test()
    #menu()
    #print "Enter Choice : "
    #inp = raw_input()
    #if inp == '1':
    #    print "Enter LED no (0-2) : "
    #    inpled = raw_input()
    #    print "Turn it on or off (0 = off, 1 = on)"
    #    onoff = raw_input()
    #    if inpled == '0':
    #        if onoff == '0':
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0000)
    #        elif onoff == '1':
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0100)
    #    elif inpled == '1':
    #        if onoff == '0':
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0001)
    #        elif onoff == '1':
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0101)
    #    elif inpled == '2':
    #        if onoff == '0':
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0002)
    #        elif onoff == '1':
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0102)
    #elif inp == '2':
    #    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
    #    t = handle.controlMsg(req, 1, 1)
    #    print t[0]
    #   if t[0] == 0:
    #        print "The switch is currently OFF"
    #    elif t[0] == 1:
    #        print "The switch is currently ON"
    #elif inp == '3':
    #    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
    #   t = handle.controlMsg(req, 2, 2)
    #    s = (((t[0]*256)+t[1])*5)/1023.00
    #    print "%.2f"%s
    #elif inp == '4':
    #    break
    #elif inp == '5':
    #    a =0
    #    while(a<20):
    #        if a%2==0:
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0105)
    #        if a%2!=0:
    #            req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #            handle.controlMsg(req, 0, None, value=0x0005)
    #        sleep(0.1)
    #        a=a+1
    #elif inp == '6':
    #    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    #    handle.controlMsg(req, 0, None, value=0x0005)
